/**
 * 演示程序当前的 “注册/登录” 等操作，是基于 “本地存储” 完成的
 * 当您要参考这个演示程序进行相关 app 的开发时，
 * 请注意将相关方法调整成 “基于服务端Service” 的实现。
 **/


(function($, owner) {
	
	owner.appKey = "85349b46-d11c-4d9f-bd8f-0aca05a10fa6";
	owner.appSecret = "8a7f737d-b44d-4636-8038-a00d539624d8";
	owner.host = "http://ynart.evoartexam.cn/evoartexam/";
	owner.apiUrl = "http://ynart.evoartexam.cn/evoartexam/api/";
	//owner.host = "http://evoimagine.evoartexam.cn/evoartexam/";
	//owner.apiUrl = "http://evoimagine.evoartexam.cn/evoartexam/api/";
	owner.isDebug=true;
	
	/**
	 * 获取应用程序令牌
	 **/
	owner.getAppToken = function() {
		var value = localStorage.getItem('$appToken') || "{}";
		return JSON.parse(value);
	};

	/**
	 * 设置应用程序令牌
	 **/
	owner.setAppToken = function(value) {
		value = value || {};
		localStorage.setItem('$appToken', JSON.stringify(value));
	};
	
	/**
	 * 获取App令牌
	 */
	owner.createAppToken = function() {
		console.log(owner.apiUrl + 'appToken')
		$.ajax({
            url      : owner.apiUrl + 'appToken',
            crossDomain : true,
            async	 : false,
            data	 : { 
            	appKey : owner.appKey,
            	appSecret : owner.appSecret
            },
            dataType : 'JSON',
            type     : 'GET',
            success  : function(data, status, xhr){
            	if(owner.isDebug){
            		console.log(JSON.stringify(data));
            	}
            	var result = JSON.parse(data);
            	owner.setAppToken(result['appToken']);
            },
            error    : function(xhr, type, errorThrown){
               console.log(JSON.stringify(xhr));
               console.log(type.toString());
                console.dir(errorThrown)
               //alert("错误："+errorThrown);
            }
        });
	};
	
	/**
	 * 获取应用程序令牌
	 **/
	owner.getSite = function() {
		var stateText = localStorage.getItem('$site') || "{}";
		return JSON.parse(stateText);
	};
	
	owner.getSiteUrl = function(method) {
		return owner.getSite().dynamicPath + "api/" + method;
	}

	/**
	 * 设置应用程序令牌
	 **/
	owner.setSite = function(site) {
		site = site || {};
		localStorage.setItem('$site', JSON.stringify(site));
	};
	
	/**
	 * 获得站点信息
	 */
	owner.createSite = function() {
		
		$.ajax({
            url      : owner.apiUrl + 'getSites',
            crossDomain : true,
            async	 : false,
            data	 : { 
            	appToken : owner.getAppToken()
            },
            dataType : 'JSON',
            type     : 'GET',
            success  : function(data, status, xhr){
            	 	if(owner.isDebug){
            		console.log(JSON.stringify(data));
            	}
            	var result = JSON.parse(data);
            	if (result['sites'] && result['sites'].length && (result['sites'].length > 0)) {
            		owner.setSite(result['sites'][0]);
            	}
            },
            error    : function(xhr, type, errorThrown){
                alert("错误："+errorThrown);
            }
        });
	};
	
	/**
	 * 用户登录
	 **/
	owner.login = function(loginInfo, callback) {
		callback = callback || $.noop;
		loginInfo = loginInfo || {};
		loginInfo.username = loginInfo.username || '';
		loginInfo.password = loginInfo.password || '';
		if (loginInfo.username.length < 5) {
			return callback('账号最短为 5 个字符');
		}
		if (loginInfo.password.length < 1) {
			return callback('密码不能为空');
		}
		if(owner.isDebug){
			console.log(owner.getSiteUrl('stuLogin'))
		}		
		$.ajax({
            url      : owner.getSiteUrl('stuLogin'),
            //url:owner.apiUrl+'api/login',
            crossDomain : true,
            async	 : false,
            data	 : { 
            	username : loginInfo.username,
            	password : loginInfo.password,
            	appToken : owner.getAppToken()
            },
            dataType : 'JSON',
            type     : 'GET',
            success  : function(data, status, xhr){
            	if(owner.isDebug){
            		//alert(data)
            		//console.log(data)
            	}
            	var r = JSON.parse(data);
            	if (r && r.result) {
            		if(r.needChangePwd){
            			plus.nativeUI.confirm("您的密码为初始密码，为安全起见，请及时修改密码！" , function(e){
					console.log(e.index)
					if(e.index == 0){
						owner.toPage("changePwd","pages/me/changePwd.html",{},{});
					}
				},"安全提示",["确定","取消"]);
            		}
            		
            		return owner.createState(r, callback);
            	}
            	else 
            		callback("用户名或密码错误！!");
            },
            error    : function(xhr, type, errorThrown){
                alert("错误："+errorThrown);
            }
        });
	};
	
	/**
	 * 退出
	 */
	owner.logout = function() {
		owner.setState(null);
	}

	/**
	 * 创建状态
	 */
	owner.createState = function(result, callback) {
		var state = owner.getState();
		state.username = result.user.name;
		//console.log(state.username);
		state.token = result.authToken;//返回的authToken存放user tokern
		state.stuInfo =result.stuInfo; 
		owner.setState(state);
		return callback();
	};

	/**
	 * 新用户注册
	 **/
	owner.reg = function(regInfo, callback) {
		callback = callback || $.noop;
		regInfo = regInfo || {};
		regInfo.account = regInfo.account || '';
		regInfo.password = regInfo.password || '';
		if (regInfo.account.length < 5) {
			return callback('用户名最短需要 5 个字符');
		}
		if (regInfo.password.length < 6) {
			return callback('密码最短需要 6 个字符');
		}
		if (!checkEmail(regInfo.email)) {
			return callback('邮箱地址不合法');
		}
		var users = JSON.parse(localStorage.getItem('$users') || '[]');
		users.push(regInfo);
		localStorage.setItem('$users', JSON.stringify(users));
		return callback();
	};

	/**
	 * 获取当前状态
	 **/
	owner.getState = function() {
		var stateText = localStorage.getItem('$state') || "{}";
		var state = JSON.parse(stateText);
		
		return state;
		
	};

	/**
	 * 设置当前状态
	 **/
	owner.setState = function(state) {
		state = state || {};
		localStorage.setItem('$state', JSON.stringify(state));
	};

	var checkEmail = function(email) {
		email = email || '';
		return (email.length > 3 && email.indexOf('@') > -1);
	};

	/**
	 * 找回密码
	 **/
	owner.forgetPassword = function(email, callback) {
		callback = callback || $.noop;
		if (!checkEmail(email)) {
			return callback('邮箱地址不合法');
		}
		return callback(null, '新的随机密码已经发送到您的邮箱，请查收邮件。');
	};

	/**
	 * 获取应用本地配置
	 **/
	owner.setSettings = function(settings) {
		settings = settings || {};
		localStorage.setItem('$settings', JSON.stringify(settings));
	}

	/**
	 * 设置应用本地配置
	 **/
	owner.getSettings = function() {
		var settingsText = localStorage.getItem('$settings') || "{}";
		return JSON.parse(settingsText);
	}
	
	/**
	 * 获取本地是否安装客户端
	 **/
	owner.isInstalled = function(id) {
		if (id === 'qihoo' && mui.os.plus) {
			return true;
		}
		if (mui.os.android) {
			var main = plus.android.runtimeMainActivity();
			var packageManager = main.getPackageManager();
			var PackageManager = plus.android.importClass(packageManager)
			var packageName = {
				"qq": "com.tencent.mobileqq",
				"weixin": "com.tencent.mm",
				"sinaweibo": "com.sina.weibo"
			}
			try {
				return packageManager.getPackageInfo(packageName[id], PackageManager.GET_ACTIVITIES);
			} catch (e) {}
		} else {
			switch (id) {
				case "qq":
					var TencentOAuth = plus.ios.import("TencentOAuth");
					return TencentOAuth.iphoneQQInstalled();
				case "weixin":
					var WXApi = plus.ios.import("WXApi");
					return WXApi.isWXAppInstalled()
				case "sinaweibo":
					var SinaAPI = plus.ios.import("WeiboSDK");
					return SinaAPI.isWeiboAppInstalled()
				default:
					break;
			}
		}
	}
	
	/**
	 * 获取登录用户信息
	 */
	owner.getUserInfo = function(callback) {
		var state = owner.getState();
		$.ajax({
            url      : owner.getSiteUrl('getUserInfo'),
            crossDomain : true,
            async	 : false,
            data	 : { 
            	appToken : owner.getAppToken(),
            	authToken : state.token,
            },
            dataType : 'JSON',
            type     : 'GET', 
            success  : function(data, status, xhr){
            	var r = JSON.parse(data);
            	if (r && callback) {
            		callback(r.user, r.roleViews);
            	};
            },
            error    : function(xhr, type, errorThrown){
                alert("错误："+errorThrown);
            }
        });
        
	}
	
	/**
	 * 转到页面
	 */
	owner.toPage = function(pageId, pageUrl, pageStyles, extras) {
		$.openWindow({
			id		: pageId,
			url		: pageUrl,
			styles	: pageStyles,
			extras 	: extras,
			show: {
				autoShow	: true,
				aniShow		: 'pop-in'
			},
			waiting: {
				autoShow	: 	true,
				title		:	'正在加载...'
			}
		});
	}
	
	/**
	 * 获取考委实名信息
	 */
	owner.getTeacherInfo = function(callback) {
		var state = owner.getState();
		
		$.ajax({
            url      : owner.getSiteUrl('getTeacherInfo'),
            crossDomain : true,
            async	 : false,
            data	 : { 
            	appToken : owner.getAppToken(),
            	authToken : state.token,
            },
            dataType : 'JSON',
            type     : 'GET', 
            success  : function(data, status, xhr){
            	var r = JSON.parse(data);
            	if (r && callback) {
            		callback(r.teacher);
            	};
            },
            error    : function(xhr, type, errorThrown){
                alert("错误："+errorThrown);
            }
        });
        
	}
	
	/**
	 * 获取批次列表
	 */
	owner.getBacthList = function(stateIds, callback, picker) {
		var state = owner.getState();
		
		$.ajax({
            url      : owner.getSiteUrl('getBatchList'),
            crossDomain : true,
            async	 : true,
            data	 : { 
            	appToken 	: owner.getAppToken(),
            	authToken 	: state.token,
            	stateIds	: stateIds
            },
            dataType : 'JSON',
            type     : 'GET', 
            success  : function(data, status, xhr){
            	if(owner.isDebug){
            		console.log(JSON.stringify(data));
            	}
            	var r = JSON.parse(data);
            	if (r && callback) {
            		callback(picker, r.items);
            	};
            },
            error    : function(xhr, type, errorThrown){
                alert("错误："+errorThrown);
            }
        });
        
	}
	/**
	 * 获取批次列表
	 */
	owner.getMajorList = function(bacthId, callback, picker) {
		var state = owner.getState();
		
		$.ajax({
            url      : owner.getSiteUrl('getMajorList'),
            crossDomain : true,
            async	 : true,
            data	 : { 
	            	appToken 	: owner.getAppToken(),
	            	authToken 	: state.token,
	            	bacthId	    : bacthId
            },
            dataType : 'JSON',
            type     : 'GET', 
            success  : function(data, status, xhr){
            	var r = JSON.parse(data);
            	if (r && callback) {
            		callback(picker, r.items);
            	};
            },
            error    : function(xhr, type, errorThrown){
                alert("错误："+errorThrown);
            }
        });
        
	}
	/**
	 * 获取科目列表
	 */
	owner.getSubjectList = function(batchId, callback, picker) {
		var state = owner.getState();
		
		$.ajax({
            url      : owner.getSiteUrl('getSubjectList'),
            crossDomain : true,
            async	 : true,
            data	 : { 
            	appToken 	: owner.getAppToken(),
            	authToken 	: state.token,
            	batchId		: batchId
            },
            dataType : 'JSON',
            type     : 'GET', 
            success  : function(data, status, xhr){
            	var r = JSON.parse(data);
            	if (r && callback) {
            		callback(picker, r.items);
            	};
            },
            error    : function(xhr, type, errorThrown){
                alert("错误："+errorThrown);
            }
        });
        
	}
	
	/**
	 * 获取题目列表
	 */
	owner.getQuestionList = function(subjectId, callback, picker) {
		var state = owner.getState();
		
		$.ajax({
            url      : owner.getSiteUrl('getQuestionList'),
            crossDomain : true,
            async	 : true,
            data	 : { 
            	appToken 	: owner.getAppToken(),
            	authToken 	: state.token,
            	subjectId	: subjectId
            },
            dataType : 'JSON',
            type     : 'GET', 
            success  : function(data, status, xhr){
            	var r = JSON.parse(data);
            	if (r && callback) {
            		callback(picker, r.items);
            	};
            },
            error    : function(xhr, type, errorThrown){
                alert("错误："+errorThrown);
            }
        });
        
	}
	
	/**
	 * 获取表演类时段列表
	 */
	owner.getPfmTimeList = function(subjectId, callback, picker) {
		var state = owner.getState();
		
		$.ajax({
            url      : owner.getSiteUrl('getPfmTimeList'),
            crossDomain : true,
            async	 : true,
            data	 : { 
            	appToken 	: owner.getAppToken(),
            	authToken 	: state.token,
            	subjectId	: subjectId
            },
            dataType : 'JSON',
            type     : 'GET', 
            success  : function(data, status, xhr){
            	var r = JSON.parse(data);
            	if (r && callback) {
            		callback(picker, r.items);
            	};
            },
            error    : function(xhr, type, errorThrown){
                alert("错误："+errorThrown);
            }
        });
        
	}
	
	/**
	 * 获取题目小分
	 */
	owner.getSbjQstScores = function(questionId, pageIndex, count, callback) {
		var state = owner.getState();
		
		$.ajax({
            url      : owner.getSiteUrl('getSbjQstScores'),
            crossDomain : true,
            async	 : true,
            data	 : { 
            	appToken 	: owner.getAppToken(),
            	authToken 	: state.token,
            	questionId	: questionId,
            	pageIndex	: pageIndex,
            	count		: count
            },
            dataType : 'JSON',
            type     : 'GET', 
            success  : function(data, status, xhr){
            	var r = JSON.parse(data);
            	if (r && callback) {
            		callback(r.total, r.items);
            	};
            },
            error    : function(xhr, type, errorThrown){
                alert("错误："+errorThrown);
            }
        });
        
	}
	
	/**
	 * 提交小题分
	 */
	owner.submitSbjQstScore = function(scoreId, score, callback, objScore) {
		var state = owner.getState();
		
		$.ajax({
            url      : owner.getSiteUrl('submitSbjQstScore'),
            crossDomain : true,
            async	 : true,
            data	 : { 
            	appToken 	: owner.getAppToken(),
            	authToken 	: state.token,
            	scoreId		: scoreId,
            	score		: score
            },
            dataType : 'JSON',
            type     : 'GET', 
            success  : function(data, status, xhr){
            	if (callback) {
            		callback(objScore, true);
            	};
            },
            error    : function(xhr, type, errorThrown){
                mui.toast("错误："+errorThrown);
            }
        });
	}
	
	/**
	 * 获取表演类待考试队列
	 */
	owner.getPfmWaitingGroupList = function(timeId, callback, picker) {
		var state = owner.getState();
		
		$.ajax({
            url      : owner.getSiteUrl('getPfmWaitingGroupList'),
            crossDomain : true,
            async	 : true,
            data	 : { 
            	appToken 	: owner.getAppToken(),
            	authToken 	: state.token,
            	timeId		: timeId
            },
            dataType : 'JSON',
            type     : 'GET', 
            success  : function(data, status, xhr){
            	var r = JSON.parse(data);
            	if (r && callback) {
            		callback(picker, r.items, r.minScore, r.maxScore);
            	};
            },
            error    : function(xhr, type, errorThrown){
                alert("错误："+errorThrown);
            }
        });
        
	}
	
	/**
	 * 按组获取表演类科目评分数据
	 */
	owner.getPfmScores = function(groupId, callback) {
		var state = owner.getState();
		
		$.ajax({
            url      : owner.getSiteUrl('getPfmScores'),
            crossDomain : true,
            async	 : true,
            data	 : { 
            	appToken 	: owner.getAppToken(),
            	authToken 	: state.token,
            	groupId		: groupId
            },
            dataType : 'JSON',
            type     : 'GET', 
            success  : function(data, status, xhr){
            	var r = JSON.parse(data);
            	if (r && callback) {
            		callback(r.total, r.items);
            	};
            },
            error    : function(xhr, type, errorThrown){
                alert("错误："+errorThrown);
            }
        });
        
	}
	
	/**
	 * 提交表演类考生的成绩
	 */
	owner.submitPfmScore = function(scoreId, score, callback, objScore) {
		var state = owner.getState();
		
		$.ajax({
            url      : owner.getSiteUrl('submitPfmScore'),
            crossDomain : true,
            async	 : true,
            data	 : { 
            	appToken 	: owner.getAppToken(),
            	authToken 	: state.token,
            	scoreId		: scoreId,
            	score		: score
            },
            dataType : 'JSON',
            type     : 'GET', 
            success  : function(data, status, xhr){
            	if (callback) {
            		callback(objScore, true);
            	};
            },
            error    : function(xhr, type, errorThrown){
                mui.toast("错误："+errorThrown);
            }
        });
	}
	
	/**
	 * 获取表现类评分组
	 */
	owner.getRprGroupList = function(subjectId, callback, picker) {
		var state = owner.getState();
		
		$.ajax({
            url      : owner.getSiteUrl('getRprGroupList'),
            crossDomain : true,
            async	 : true,
            data	 : { 
            	appToken 	: owner.getAppToken(),
            	authToken 	: state.token,
            	subjectId	: subjectId
            },
            dataType : 'JSON',
            type     : 'GET', 
            success  : function(data, status, xhr){
            	var r = JSON.parse(data);
            	if (r && callback) {
            		callback(picker, r.items);
            	};
            },
            error    : function(xhr, type, errorThrown){
                alert("错误："+errorThrown);
            }
        });
        
	}
	
	/**
	 * 按组获取表现类科目等级评定数据
	 */
	owner.getRprLevels = function(groupId, callback) {
		var state = owner.getState();
		
		$.ajax({
            url      : owner.getSiteUrl('getRprLevels'),
            crossDomain : true,
            async	 : true,
            data	 : { 
            	appToken 	: owner.getAppToken(),
            	authToken 	: state.token,
            	groupId		: groupId
            },
            dataType : 'JSON',
            type     : 'GET', 
            success  : function(data, status, xhr){
            	console.log(data)
            	var r = JSON.parse(data);
            	if (r && callback) {
            		callback(r.total, r.items);
            	};
            },
            error    : function(xhr, type, errorThrown){
                alert("错误："+errorThrown);
            }
        });
        
	}
	
	/**
	 * 提交表现类考生的等级
	 */
	owner.submitRprLevel = function(dataId, levelId, callback, objLevel) {
		var state = owner.getState();
		
		$.ajax({
            url      : owner.getSiteUrl('submitRprLevel'),
            crossDomain : true,
            async	 : true,
            data	 : { 
            	appToken 	: owner.getAppToken(),
            	authToken 	: state.token,
            	dataId		: dataId,
            	levelId		: levelId
            },
            dataType : 'JSON',
            type     : 'GET', 
            success  : function(data, status, xhr){
            	if (callback) {
            		callback(objLevel, true);
            	};
            },
            error    : function(xhr, type, errorThrown){
                mui.toast("错误："+errorThrown);
            }
        });
	}
	
	/**
	 * 按组获取表现类科目评分数据
	 */
	owner.getRprScores = function(groupId, callback) {
		var state = owner.getState();
		
		$.ajax({
            url      : owner.getSiteUrl('getRprScores'),
            crossDomain : true,
            async	 : true,
            data	 : { 
            	appToken 	: owner.getAppToken(),
            	authToken 	: state.token,
            	groupId		: groupId
            },
            dataType : 'JSON',
            type     : 'GET', 
            success  : function(data, status, xhr){
            	var r = JSON.parse(data);
            	if (r && callback) {
            		callback(r.total, r.items);
            	};
            },
            error    : function(xhr, type, errorThrown){
                alert("错误："+errorThrown);
            }
        });
        
	}
	
	/**
	 * 提交表现类考生的评分
	 */
	owner.submitRprScore = function(dataId, score, callback, objScore) {
		var state = owner.getState();
		
		$.ajax({
            url      : owner.getSiteUrl('submitRprScore'),
            crossDomain : true,
            async	 : true,
            data	 : { 
            	appToken 	: owner.getAppToken(),
            	authToken 	: state.token,
            	dataId		: dataId,
            	score		: score
            },
            dataType : 'JSON',
            type     : 'GET', 
            success  : function(data, status, xhr){
            	if (callback) {
            		callback(objScore, true);
            	};
            },
            error    : function(xhr, type, errorThrown){
                mui.toast("错误："+errorThrown);
            }
        });
	}
	
	/**
	 * 申请改变笔试科目题目分数
	 * @param {Object} dataId
	 * @param {Object} score
	 * @param {Object} callback
	 */
	owner.wantChangeSbjQstScore = function(dataId, callback) {
		var state = owner.getState();
		
		$.ajax({
            url      : owner.getSiteUrl('wantChangeSbjQstScore'),
            crossDomain : true,
            async	 : true,
            data	 : { 
            	appToken 	: owner.getAppToken(),
            	authToken 	: state.token,
            	dataId		: dataId
            },
            dataType : 'JSON',
            type     : 'GET', 
            success  : function(data, status, xhr){
            	if (callback) {
            		callback(true);
            	};
            },
            error    : function(xhr, type, errorThrown){
                mui.toast("错误："+errorThrown);
            }
        });
	}
	
	/**
	 * 申请改变表演类分数
	 * @param {Object} dataId
	 * @param {Object} score
	 * @param {Object} callback
	 */
	owner.wantChangePfmScore = function(dataId, callback) {
		var state = owner.getState();
		
		$.ajax({
            url      : owner.getSiteUrl('wantChangePfmScore'),
            crossDomain : true,
            async	 : true,
            data	 : { 
            	appToken 	: owner.getAppToken(),
            	authToken 	: state.token,
            	dataId		: dataId
            },
            dataType : 'JSON',
            type     : 'GET', 
            success  : function(data, status, xhr){
            	if (callback) {
            		callback(true);
            	};
            },
            error    : function(xhr, type, errorThrown){
                mui.toast("错误："+errorThrown);
            }
        });
	}
	
	/**
	 * 申请改变表现类等级
	 * @param {Object} dataId
	 * @param {Object} score
	 * @param {Object} callback
	 */
	owner.wantChangeRprLevel = function(dataId, callback) {
		var state = owner.getState();
		
		$.ajax({
            url      : owner.getSiteUrl('wantChangeRprLevel'),
            crossDomain : true,
            async	 : true,
            data	 : { 
            	appToken 	: owner.getAppToken(),
            	authToken 	: state.token,
            	dataId		: dataId
            },
            dataType : 'JSON',
            type     : 'GET', 
            success  : function(data, status, xhr){
            	if (callback) {
            		callback(true);
            	};
            },
            error    : function(xhr, type, errorThrown){
                mui.toast("错误："+errorThrown);
            }
        });
	}
	
	/**
	 * 申请改变表现类分数
	 * @param {Object} dataId
	 * @param {Object} score
	 * @param {Object} callback
	 */
	owner.wantChangeRprScore = function(dataId, callback) {
		var state = owner.getState();
		
		$.ajax({
            url      : owner.getSiteUrl('wantChangeRprScore'),
            crossDomain : true,
            async	 : true,
            data	 : { 
            	appToken 	: owner.getAppToken(),
            	authToken 	: state.token,
            	dataId		: dataId
            },
            dataType : 'JSON',
            type     : 'GET', 
            success  : function(data, status, xhr){
            	if (callback) {
            		callback(true);
            	};
            },
            error    : function(xhr, type, errorThrown){
                mui.toast("错误："+errorThrown);
            }
        });
	}
	
}(mui, window.app = {}));