/**
 * 弹出评分插件
 * version 1.0.1
 */

(function($, document) {

	//创建 DOM
	$.dom = function(str) {
		if (typeof(str) !== 'string') {
			if ((str instanceof Array) || (str[0] && str.length)) {
				return [].slice.call(str);
			} else {
				return [str];
			}
		}
		if (!$.__create_dom_div__) {
			$.__create_dom_div__ = document.createElement('div');
		}
		$.__create_dom_div__.innerHTML = str;
		return [].slice.call($.__create_dom_div__.childNodes);
	};

	var panelBuffer = '<div class="mui-popkb">\
		<div class="mui-popkb-header">\
			<table width="100%">\
				<tr>\
					<td colspan="5" width="100%"><div class="mui-popkb-mini-title">title</div></td>\
				</tr>\
				<tr>\
					<td width="20%"><button class="mui-btn mui-popkb-btn-cancel">取消</button></td>\
					<td width="15%"><div class="mui-popkb-min"></div></td>\
					<td width="30%"><div class="mui-popkb-mini-scr"></div></td>\
					<td width="15%"><div class="mui-popkb-max"></div></td>\
					<td width="20%"><button class="mui-btn mui-btn-blue mui-popkb-btn-ok">确定</button></td>\
				</tr>\
			</table>\
		</div>\
		<div class="mui-popkb-body">\
		</div>\
	</div>';

	var pickerBuffer = '<div class="mui-picker">\
		<div class="mui-popkb-inner">\
			<table width="100%" height="100%">\
				<tr>\
					<td width="33%" height="25%" align="center"><button class="mui-btn mui-popkb-btn-num mui-popkbn7">7</button></td>\
					<td width="33%" align="center"><button class="mui-btn mui-popkb-btn-num mui-popkbn8">8</button></td>\
					<td width="34%" align="center"><button class="mui-btn mui-popkb-btn-num mui-popkbn9">9</button></td>\
				</tr>\
				<tr>\
					<td height="25%" align="center"><button class="mui-btn mui-popkb-btn-num mui-popkbn4">4</button></td>\
					<td align="center"><button class="mui-btn mui-popkb-btn-num mui-popkbn5">5</button></td>\
					<td align="center"><button class="mui-btn mui-popkb-btn-num mui-popkbn6">6</button></td>\
				</tr>\
				<tr>\
					<td height="25%" align="center"><button class="mui-btn mui-popkb-btn-num mui-popkbn1">1</button></td>\
					<td align="center"><button class="mui-btn mui-popkb-btn-num mui-popkbn2">2</button></td>\
					<td align="center"><button class="mui-btn mui-popkb-btn-num mui-popkbn3">3</button></td>\
				</tr>\
				<tr>\
					<td height="25%" align="center"><button class="mui-btn mui-popkb-btn-num mui-popkbn0">0</button></td>\
					<td align="center"><button class="mui-btn mui-popkb-btn-num mui-popkbclr">清除</button></td>\
					<td align="center"><button class="mui-btn mui-popkb-btn-num mui-popkbdot">.</button></td>\
				</tr>\
			</table>\
		</div>\
	</div>';

	//定义弹出键盘
	var PopKb = $.PopKb = $.Class.extend({
		//构造函数
		init: function(options) {
			var self = this;
			self.options = options || {};
			self.options.min = self.options.min || 0.0;
			self.options.max = self.options.max || 100.0;
			self.options.buttons = self.options.buttons || ['取消', '确定'];
			self.panel = $.dom(panelBuffer)[0];
			document.body.appendChild(self.panel);
			self.miniTitle = self.panel.querySelector('.mui-popkb-mini-title');//mini标题
			self.ok = self.panel.querySelector('.mui-popkb-btn-ok');
			self.miniScr = self.panel.querySelector('.mui-popkb-mini-scr');//mini回显屏幕
			self.minTip = self.panel.querySelector('.mui-popkb-min');//min回显
			self.maxTip = self.panel.querySelector('.mui-popkb-max');//max回显
			self.cancel = self.panel.querySelector('.mui-popkb-btn-cancel');
			self.body = self.panel.querySelector('.mui-popkb-body');
			
			self.mask = $.createMask();
			self.cancel.innerText = self.options.buttons[0];
			self.ok.innerText = self.options.buttons[1];
			self.miniScr.innerText = "0";
			self.cancel.addEventListener('tap', function(event) {
				self.hide();
			}, false);
			self.ok.addEventListener('tap', function(event) {
				//alert(self.getValue());
				var r = /^[0-9]+\.?[0-9]*?$/; //小数的正则表达式
				var testValue = self.getValue();
				if (r.test(testValue)) {
					var tmpValue = parseFloat(testValue);
					if ((tmpValue >= self.options.min) && (tmpValue < self.options.max)) {
						if (self.callback) {
							var rs = self.callback(testValue);
							if (rs !== false) {
								self.hide();
							}
						}
					}//数据有效
				}//
				
			}, false);
			
			self.mask[0].addEventListener('tap', function() {
				self.hide();
			}, false);
			self._createPicker();
			
			self.numBtn0 = self.body.querySelector('.mui-popkbn0');
			self.numBtn1 = self.body.querySelector('.mui-popkbn1');
			self.numBtn2 = self.body.querySelector('.mui-popkbn2');
			self.numBtn3 = self.body.querySelector('.mui-popkbn3');
			self.numBtn4 = self.body.querySelector('.mui-popkbn4');
			self.numBtn5 = self.body.querySelector('.mui-popkbn5');
			self.numBtn6 = self.body.querySelector('.mui-popkbn6');
			self.numBtn7 = self.body.querySelector('.mui-popkbn7');
			self.numBtn8 = self.body.querySelector('.mui-popkbn8');
			self.numBtn9 = self.body.querySelector('.mui-popkbn9');
			self.numBtnClear = self.body.querySelector('.mui-popkbclr');
			self.numBtnDot = self.body.querySelector('.mui-popkbdot');
			
			self.numBtn0.addEventListener('tap', function(event){
				self.addData('0');
			});
			self.numBtn1.addEventListener('tap', function(event){
				self.addData('1');
			});
			self.numBtn2.addEventListener('tap', function(event){
				self.addData('2');
			});
			self.numBtn3.addEventListener('tap', function(event){
				self.addData('3');
			});
			self.numBtn4.addEventListener('tap', function(event){
				self.addData('4');
			});
			self.numBtn5.addEventListener('tap', function(event){
				self.addData('5');
			});
			self.numBtn6.addEventListener('tap', function(event){
				self.addData('6');
			});
			self.numBtn7.addEventListener('tap', function(event){
				self.addData('7');
			});
			self.numBtn8.addEventListener('tap', function(event){
				self.addData('8');
			});
			self.numBtn9.addEventListener('tap', function(event){
				self.addData('9');
			});
			self.numBtnClear.addEventListener('tap', function(event){
				self.setData('0');
			});
			self.numBtnDot.addEventListener('tap', function(event){
				self.addData('.');
			});
		},
		_createPicker: function() {
			var self = this;
			var pickerElement = $.dom(pickerBuffer)[0];
			pickerElement.style.width = '100%';
			self.body.appendChild(pickerElement);
			pickerElement.addEventListener('change', function(event) {
				
			}, false);
		},
		//添加标题
		setTitle: function(data) {
			var self = this;
			self.miniTitle.innerText = data;
		},
		//添加数据
		addData: function(data) {
			var self = this;
			var r = /^[0-9]+\.?[0-9]*?$/; //小数的正则表达式
			if (r.test(self.miniScr.innerText + data)) {
				var tmpValue = parseFloat(self.miniScr.innerText + data);
				//if ((tmpValue >= self.options.min) && (tmpValue <= self.options.max)) {
				if (tmpValue < self.options.max) {
					self.miniScr.innerText = self.miniScr.innerText + data;
				}
			}
		},
		//填充数据
		setData: function(data) {
			var self = this;
			var r = /^[0-9]+\.?[0-9]*?$/; //小数的正则表达式
			if (r.test(data)) {
				var tmpValue = parseFloat(data);
				//if ((tmpValue >= self.options.min) && (tmpValue <= self.options.max))
				if (tmpValue < self.options.max) {
					self.miniScr.innerText = data;
				}
			}
		},
		//获取值
		getValue: function() {
			var self = this;
			return parseFloat(self.miniScr.innerText);
		},
		//显示
		show: function(callback) {
			var self = this;
			self.minTip.innerText = self.options.min;
			self.maxTip.innerText = self.options.max;
			
			self.callback = callback;
			self.mask.show();
			document.body.classList.add($.className('poppicker-active-for-page'));
			self.panel.classList.add($.className('active'));
			//处理物理返回键
			self.__back = $.back;
			$.back = function() {
				self.hide();
			};
		},
		//隐藏
		hide: function() {
			var self = this;
			if (self.disposed) return;
			self.panel.classList.remove($.className('active'));
			self.mask.close();
			document.body.classList.remove($.className('poppicker-active-for-page'));
			//处理物理返回键
			$.back=self.__back;
		},
		dispose: function() {
			var self = this;
			self.hide();
			setTimeout(function() {
				self.panel.parentNode.removeChild(self.panel);
				for (var name in self) {
					self[name] = null;
					delete self[name];
				};
				self.disposed = true;
			}, 300);
		}
	});

})(mui, document);