/**
 * 初始化令牌
 * @param {Object} doc
 * @param {Object} owner
 */
function initToken(doc, owner) {
	
	owner.createAppToken();//创建App令牌
		
	owner.createSite();//创建站点信息
	if (owner.getSite()) {
		var imgLogo = doc.getElementById('platformLogo');
		imgLogo.setAttribute('src', owner.getSite().sitePath+'images/logo_m.png');
		imgLogo.setAttribute('alt', owner.getSite().name);
		
		var platformTitle = doc.getElementById('platformTitle');
		platformTitle.innerHTML = owner.getSite().name;
	}
}

function downWgt(wgtUrl){
    plus.nativeUI.showWaiting("下载wgt文件...");
    plus.downloader.createDownload( wgtUrl, {filename:"_doc/update/"}, function(d,status){
       console.log(status)
       if ( status == 200 ) {
            console.log("下载wgt成功："+d.filename);
            installWgt(d.filename); // 安装wgt包
            plus.nativeUI.closeWaiting();
        } else {
            console.log("下载wgt失败！");
            plus.nativeUI.alert("下载wgt失败！");
        }
        plus.nativeUI.closeWaiting();
    }).start();
}

// 更新应用资源
function installWgt(path){
    plus.nativeUI.showWaiting("安装wgt文件...");
    plus.runtime.install(path,{},function(){
        plus.nativeUI.closeWaiting();
        console.log("安装wgt文件成功！");
        plus.nativeUI.alert("应用资源更新完成！",function(){
            plus.runtime.restart();
        });
    },function(e){
        plus.nativeUI.closeWaiting();
        console.log("安装wgt文件失败["+e.code+"]："+e.message);
        plus.nativeUI.alert("安装wgt文件失败["+e.code+"]："+e.message);
    });
}

(function($, doc) {
	$.init({
		statusBarBackground: '#f7f7f7'
	});
	
	$.plusReady(function() {
		plus.screen.lockOrientation("portrait-primary");
		var settings = app.getSettings();
		 // 获取本地应用资源版本号
		
		initToken(doc, app);//初始化令牌
		
	    plus.runtime.getProperty(plus.runtime.appid,function(inf){
	        wgtVer=inf.version;
	       	wgtAppid = inf.appid;
	       	reqwest({
				url: app.apiUrl+'checkAppUpdate?appId='+wgtAppid+'&version='+wgtVer,
				type: 'json',
				method: 'get',
				contentType: 'application/json',
				crossOrigin: true,
				error: function(err) {
					
				},
				success: function(resp) {
					console.log(JSON.stringify(resp))
					if(resp.success) {
						plus.nativeUI.confirm("检测到新版本，是否更新？" , function(e){
							console.log(e.index)
							if(e.index == 0){
								resp.items.forEach(function(value,index,array){
 										downWgt(value.url);
								　　});
							}
						},"更新提示",["确定","取消"]);
					}else{
						if(resp.message)
						console.log(resp.message)
					}
				},
				complete: function(resp) {
	
				}
			});
	        console.log("当前应用版本："+wgtVer);
	    });
		
		setTimeout(function() {
			plus.navigator.closeSplashscreen();
		}, 600);
		
		var loginButton = doc.getElementById('login');
		loginButton.addEventListener('tap', function(event) {
			var loginInfo = {
				username: doc.getElementById('account').value,
				password: doc.getElementById('password').value
			};
			app.login(loginInfo, function(err) {
				if (err) {
					
					plus.nativeUI.toast(err);
					return;
				}
				app.toPage('index', 'index.html', {}, {});
				
			});
		});
		
		var backButtonPress = 0;
		$.back = function(event) {
			backButtonPress++;
			if (backButtonPress > 1) {
				plus.runtime.quit();
			} else {
				plus.nativeUI.toast('再按一次退出应用');
			}
			setTimeout(function() {
				backButtonPress = 0;
			}, 1000);
			return false;
		};
	});
}(mui, document));