(function($, doc) {
	
	$.init();
	
	$.plusReady(function() {
		
		var self = plus.webview.currentWebview();
		var selGroupId = null;
		var timeId = self.timeId;
		
		var sbjText = doc.getElementById('sbjText');
		if (sbjText)
			sbjText.innerText = '考试科目：'+self.subject;
			
		var groupPicker = new $.PopPicker();
		var grid = doc.getElementById("grid");
		var popKb = new $.PopKb({
			min : 0.0,
			max : 100.0
		});
		
		//分组
		var setGroupData = function(picker, items, minScore, maxScore) {
			var data = new Array();
			for (var i=0; i<items.length; i++) {
				data.push({
					value : items[i].id,
					text  : items[i].sn
				});
			}
			picker.setData(data);
			
			popKb.options.min = minScore;
			popKb.options.max = maxScore;
		} 
		
		var showGroupPicker = doc.getElementById('showGroupPicker');
		app.getPfmWaitingGroupList(timeId, setGroupData, groupPicker);
		
		var groupText = doc.getElementById('groupText');
		showGroupPicker.addEventListener('tap', function(event) {
			groupPicker.show(function(items) {
				selGroupId = items[0].value;
				groupText.innerText = '第'+items[0].text+'组';
				
				app.getPfmScores(selGroupId, getData);
			});
		}, false);
		
		var changeFlag = function(objScore, success) {
			var newClassName = success ? "mui-badge-success" : "mui-badge-warning";
			
			if (success && objScore.classList.contains("mui-badge-warning"))
				objScore.classList.remove("mui-badge-warning");
				
			if (!objScore.classList.contains(newClassName)) {
				objScore.classList.add(newClassName);
			}
		}
		
		var tapItem = function(event) {
			var objId = this.firstElementChild;
			var objLabel = objId.nextElementSibling;
			popKb.setTitle(objLabel.innerText);
			var objScore = objLabel.nextElementSibling;
			popKb.setData(objScore.innerText);
			
			var objLocked = objScore.nextElementSibling;
			if (objLocked.getAttribute("value")==1) {
				
				mui.confirm('当前分数已锁定，确定要申请解锁吗？', '确认', ['申请', '不'], function(e) {
					if (e.index == 0) {
						//申请解锁
						app.wantChangePfmScore(objId.getAttribute('value'), function(success) {
							mui.toast('申请' + (success ? '成功' : '失败') ,{ duration:'long', type:'div' });
						});
					} 
				});
				
			} else {
				popKb.show(function(value) {
					if (objScore.innerText == value) return;
					objScore.innerText = value;
					app.submitPfmScore(objId.getAttribute('value'), value, changeFlag, objScore);
				});
			}
			
		};
		
		var getData = function(total, items) {
			//mui-active
			if (grid) {
				var html = "";
				for (var i=1; i<=items.length; i++) {
					
					var rowHtml = "<li id='row" + i + "' class='mui-table-view-cell'>";
					rowHtml += "<input id='rowId" + i + "' type='hidden' value='" + items[i-1].id + "' />";
					rowHtml += "<label id='label" + i + "'>" + '签号' + items[i-1].lotNo + "</label>";
					rowHtml += "<span id='score" + i 
						+ "' class='mui-badge " + (items[i-1].locked ? "mui-badge-success" : "mui-badge-warning") + "'>" 
						+ items[i-1].score + "</span>";
					rowHtml += "<input id='lockId" + i + "' type='hidden' value='" + (items[i-1].locked ? "1" : "0") + "' />";
					rowHtml += "</li>";
					
					html += rowHtml;
				}
				
				grid.innerHTML = html;
			}
			
			mui(".mui-table-view").on('tap','.mui-table-view-cell', tapItem);
		}
		
	});
		
}(mui, document));