(function($, doc) {
	
	$.init();
	
	$.plusReady(function() {
		
		var totalNum = 0;
		var pageCount = 0;
		var pageIndex = 1;
		var pageSize = 5;
		
		var self = plus.webview.currentWebview();
		var questionId = self.questionId;
		
		var qstText = doc.getElementById('qstText');
		if (qstText)
			qstText.innerText = '题号：'+self.question;
		
		var btnPrev = doc.getElementById('prev');
		var btnToPage = doc.getElementById('toPage');
		var btnNext = doc.getElementById('next');
		
		var updatePrev = function(pageIndex, btnPrev) {
			if ((pageIndex <= 1) && (!btnPrev.classList.contains('mui-disabled'))) {
				btnPrev.classList.add("mui-disabled");
			}
			if ((pageIndex > 1) && (btnPrev.classList.contains('mui-disabled'))) {
				btnPrev.classList.remove("mui-disabled");
			}
		}
		var updateNext = function(pageIndex, totalPage, btnNext) {
			if ((pageIndex >= totalPage) && (!btnNext.classList.contains('mui-disabled'))) {
				btnNext.classList.add("mui-disabled");
			}
			if ((pageIndex < totalPage) && (btnNext.classList.contains('mui-disabled'))) {
				btnNext.classList.remove("mui-disabled");
			}
		}
		var prevPage = function() {
			var success = false;
			if (pageIndex > 1) {
				pageIndex = pageIndex - 1;
				success = true;
			}
			updatePrev(pageIndex, btnPrev);
			updateNext(pageIndex, pageCount, btnNext);
			
			return success;
		}
		var gotoPage = function(pPageIndex) {
			pageIndex = pPageIndex;
			updatePrev(pageIndex, btnPrev);
			updateNext(pageIndex, pageCount, btnNext);
			
			return true;
		}
		var nextPage = function() {
			var success = false;
			if (pageIndex < pageCount) {
				pageIndex = pageIndex + 1;
				success = true;
			}
				
			updatePrev(pageIndex, btnPrev);
			updateNext(pageIndex, pageCount, btnNext);
			
			return success;
		}
		
		var pickerData = null;
		var pagePicker = new $.PopPicker();
		var grid = doc.getElementById("grid");
		
		var popKb = new $.PopKb({
			min : 0.0,
			max : 100.0
		});
		
		var changeFlag = function(objScore, success) {
			var newClassName = success ? "mui-badge-success" : "mui-badge-warning";
			
			if (success && objScore.classList.contains("mui-badge-warning"))
				objScore.classList.remove("mui-badge-warning");
				
			if (!objScore.classList.contains(newClassName)) {
				objScore.classList.add(newClassName);
			}
				
		}
		
		var tapItem = function(event) {
			var objId = this.firstElementChild;
			var objLabel = objId.nextElementSibling;
			popKb.setTitle(objLabel.innerText);
			var objScore = objLabel.nextElementSibling;
			popKb.setData(objScore.innerText);
			var objLocked = objScore.nextElementSibling;
			
			if (objLocked.getAttribute("value")==1) {
				
				mui.confirm('当前分数已锁定，确定要申请解锁吗？', '确认', ['申请', '不'], function(e) {
					if (e.index == 0) {
						//申请解锁
						app.wantChangeSbjQstScore(objId.getAttribute('value'), function(success) {
							mui.toast('申请' + (success ? '成功' : '失败') ,{ duration:'long', type:'div' });
						});
					} 
				});

			} else {
				popKb.show(function(value) {
					if (objScore.innerText == value) return;
					
					objScore.innerText = value;
					app.submitSbjQstScore(objId.getAttribute('value'), value, changeFlag, objScore);
				});
			}//没有锁定
			
		};
		
		var getData = function(total, items) {
			
			totalNum = total;
			pageCount = Math.ceil(totalNum/pageSize);
			pickerData = new Array();
			for (var i=1; i<=pageCount; i++) {
				pickerData.push({
					value : i,
					text  : i
				});
			}
			pagePicker.setData(pickerData);
			
			//mui-active
			if (grid) {
				var html = "";
				for (var i=1; i<=items.length; i++) {
					
					if (i == 1) {
						popKb.options.min = items[i - 1].minScore;
						popKb.options.max = items[i - 1].maxScore;
					}
					
					var rowHtml = "<li id='row" + i + "' class='mui-table-view-cell'>";
					rowHtml += "<input id='rowId" + i + "' type='hidden' value='" + items[i-1].id + "' />";
					rowHtml += "<label id='label" + i + "'>" + items[i-1].artCode + '-' + items[i-1].name + "</label>";
					rowHtml += "<span id='score" + i 
						+ "' class='mui-badge " + (items[i-1].locked ? "mui-badge-success" : "mui-badge-warning") + "'>" 
						+ items[i-1].score + "</span>";
					rowHtml += "<input id='lockId" + i + "' type='hidden' value='" + (items[i-1].locked ? "1" : "0") + "' />";
					rowHtml += "</li>";
					
					html += rowHtml;
				}
				
				grid.innerHTML = html;
			}
			
			mui(".mui-table-view").on('tap','.mui-table-view-cell', tapItem);
			
			updatePrev(pageIndex, btnPrev);
			updateNext(pageIndex, pageCount, btnNext);
		}
		
		btnPrev.addEventListener('tap', function(event) {
			if (prevPage())
				app.getSbjQstScores(questionId, pageIndex, pageSize, getData);
		});
		
		btnToPage.addEventListener('tap', function(event) {
			pagePicker.show(function(items) {
				var newPageIndex = items[0].value;
				if (gotoPage(newPageIndex, pageCount, btnPrev, btnNext))
					app.getSbjQstScores(questionId, newPageIndex, pageSize, getData);
			});
		});
		
		btnNext.addEventListener('tap', function(event) {
			if (nextPage())
				app.getSbjQstScores(questionId, pageIndex, pageSize, getData);
		});
		
		app.getSbjQstScores(questionId, pageIndex, pageSize, getData);
		
	});
		
}(mui, document));