(function($, doc) {
	
	$.init();
	
	$.plusReady(function() {
		
		var selBatchId = null;
		var selSubjectId = null;
		var selQuestionId = null;
		
		//批次
		var setBatchList = function(picker, items) {
			var data = new Array();
			for (var i=0; i<items.length; i++) {
				data.push({
					value : items[i].id,
					text  : items[i].title
				});
			}
			picker.setData(data);
		}
		
		//科目
		var setSubjectList = function(picker, items) {
			var data = new Array();
			for (var i=0; i<items.length; i++) {
				data.push({
					value : items[i].id,
					text  : items[i].name
				});
			}
			picker.setData(data);
		}
		
		//题目
		var setQuestionList = function(picker, items) {
			var data = new Array();
			for (var i=0; i<items.length; i++) {
				data.push({
					value : items[i].id,
					text  : items[i].code
				});
			}
			picker.setData(data);
		}

		var batchPicker = new $.PopPicker();
		var subjectPicker = new $.PopPicker();
		var questionPicker = new $.PopPicker();
		
		app.getBacthList([1,2,3,4], setBatchList, batchPicker);
		
		var showBatchPicker = doc.getElementById('showBatchPicker');
		var batchText = doc.getElementById('batchText');
		showBatchPicker.addEventListener('tap', function(event) {
			batchPicker.show(function(items) {
				selBatchId = items[0].value;
				batchText.innerText = items[0].text;
				
				app.getSubjectList(selBatchId, setSubjectList, subjectPicker);
			});
		}, false);
		
		var showSbjPicker = doc.getElementById('showSbjPicker');
		var sbjText = doc.getElementById('sbjText');
		showSbjPicker.addEventListener('tap', function(event) {
			subjectPicker.show(function(items) {
				selSubjectId = items[0].value;
				sbjText.innerText = items[0].text;
				
				app.getQuestionList(selSubjectId, setQuestionList, questionPicker);
			});
		}, false);
		
		var showQstPicker = doc.getElementById('showQstPicker');
		var qstText = doc.getElementById('qstText');
		showQstPicker.addEventListener('tap', function(event) {
			questionPicker.show(function(items) {
				selQuestionId = items[0].value;
				qstText.innerText = items[0].text;
			});
		}, false);
		
		
		
		var btnStart = doc.getElementById('start');
		btnStart.addEventListener('tap', function(event) {
			
			if (!selQuestionId) {
				mui.toast('请选择题号！',{ duration:'short', type:'div' });
			} else {
				app.toPage('qstScore', 'qstScore.html', {}, {
					questionId: selQuestionId,
					question: qstText.innerText
				});
			}
		});
		
	});
	
}(mui, document));