(function($, doc) {
	
	$.init();
	
	$.plusReady(function() {
		
		var self = plus.webview.currentWebview();
		var selGroupId = null;
		var subjectId = self.subjectId;
		
		var sbjText = doc.getElementById('sbjText');
		if (sbjText)
			sbjText.innerText = '考试科目：'+self.subject;
			
		var groupPicker = new $.PopPicker();
		var grid = doc.getElementById("grid");
		var popRating = new $.PopRating();
		
		//分组
		var setGroupData = function(picker, items) {
			var data = new Array();
			for (var i=0; i<items.length; i++) {
				data.push({
					value : items[i].id,
					text  : items[i].code
				});
			}
			picker.setData(data);
		} 
		
		var showGroupPicker = doc.getElementById('showGroupPicker');
		app.getRprGroupList(subjectId, setGroupData, groupPicker);
		
		var groupText = doc.getElementById('groupText');
		showGroupPicker.addEventListener('tap', function(event) {
			groupPicker.show(function(items) {
				selGroupId = items[0].value;
				groupText.innerText = '第'+items[0].text+'组';
				
				app.getRprLevels(selGroupId, getData);
			});
		}, false);
		
		var changeFlag = function(objLevel, success) {
			var newClassName = success ? "mui-badge-success" : "mui-badge-warning";
			
			if (success && objLevel.classList.contains("mui-badge-warning"))
				objLevel.classList.remove("mui-badge-warning");
				
			if (!objLevel.classList.contains(newClassName)) {
				objLevel.classList.add(newClassName);
			}
		}
		
		var tapItem = function(event) {
			var objId = this.firstElementChild;
			var levelId = objId.nextElementSibling;
			var objLabel = levelId.nextElementSibling;
			popRating.setTitle(objLabel.innerText);
			var objLevel = objLabel.nextElementSibling;
			popRating.setData(objLevel.innerText);
			
			var objLocked = objLevel.nextElementSibling;
			if (objLocked.getAttribute("value")==1) {
				mui.confirm('当前等级已锁定，确定要申请解锁吗？', '确认', ['申请', '不'], function(e) {
					if (e.index == 0) {
						//申请解锁
						app.wantChangeRprLevel(objId.getAttribute('value'), function(success) {
							mui.toast('申请' + (success ? '成功' : '失败') ,{ duration:'long', type:'div' });
						});
					} 
				});
			} else {
				popRating.show(function(value) {
					if (objLevel.innerText == value) return;
					objLevel.innerText = value;
					var newLevelId = popRating.getLevelId(value);
					
					levelId.setAttribute("value", newLevelId);
					app.submitRprLevel(objId.getAttribute('value'), newLevelId, changeFlag, objLevel);
				});
			}
			
		};
		
		var getData = function(total, items) {
			//mui-active
			if (grid) {
				var html = "";
				for (var i=1; i<=items.length; i++) {
					
					var rowHtml = "<li id='row" + i + "' class='mui-table-view-cell'>";
					rowHtml += "<input id='rowId" + i + "' type='hidden' value='" + items[i-1].id + "' />";
					rowHtml += "<input id='rowLevelId" + i + "' type='hidden' value='" + items[i-1].levelId + "' />";
					rowHtml += "<label id='label" + i + "'>" + '序号' + items[i-1].sn + "</label>";
					rowHtml += "<span id='rowLevel" + i 
						+ "' class='mui-badge " + (items[i-1].locked ? "mui-badge-success" : "mui-badge-warning") + "'>" 
						+ items[i-1].level + "</span>";
					rowHtml += "<input id='lockId" + i + "' type='hidden' value='" + (items[i-1].locked ? "1" : "0") + "' />";
					rowHtml += "</li>";
					
					html += rowHtml;
				}
				
				grid.innerHTML = html;
			}
			
			mui(".mui-table-view").on('tap','.mui-table-view-cell', tapItem);
		}
		
	});
		
}(mui, document));