(function($, doc) {
	
	$.init();
	
	$.plusReady(function() {
		
		var selBatchId = null;
		var selSubjectId = null;
		
		//批次
		var setBatchList = function(picker, items) {
			var data = new Array();
			for (var i=0; i<items.length; i++) {
				data.push({
					value : items[i].id,
					text  : items[i].title
				});
			}
			picker.setData(data);
		}
		
		//科目
		var setSubjectList = function(picker, items) {
			var data = new Array();
			for (var i=0; i<items.length; i++) {
				data.push({
					value : items[i].id,
					text  : items[i].name
				});
			}
			picker.setData(data);
		}
		
		var batchPicker = new $.PopPicker();
		var subjectPicker = new $.PopPicker();
		
		app.getBacthList([1,2,3,4], setBatchList, batchPicker);
		
		var showBatchPicker = doc.getElementById('showBatchPicker');
		var batchText = doc.getElementById('batchText');
		showBatchPicker.addEventListener('tap', function(event) {
			batchPicker.show(function(items) {
				selBatchId = items[0].value;
				batchText.innerText = items[0].text;
				
				app.getSubjectList(selBatchId, setSubjectList, subjectPicker);
			});
		}, false);
		
		var showSbjPicker = doc.getElementById('showSbjPicker');
		var sbjText = doc.getElementById('sbjText');
		showSbjPicker.addEventListener('tap', function(event) {
			subjectPicker.show(function(items) {
				selSubjectId = items[0].value;
				sbjText.innerText = items[0].text;
				
			});
		}, false);
		
		var btnStart = doc.getElementById('start');
		btnStart.addEventListener('tap', function(event) {
			
			if (!selSubjectId) {
				mui.toast('请选择科目！',{ duration:'short', type:'div' });
			} else {
				app.toPage('rprScore', 'rprScore.html', {}, {
					subjectId: selSubjectId,
					subject: sbjText.innerText
				});
			}
		});
		
	});
	
}(mui, document));